class Friend {
  def listen() { println "I'm $name listening..." }
}

@Mixin(Friend)
class Human {
  String name
  public Human(personName) { name = personName }
}

def hangoutWith(friend) { friend.listen() }

joe = new Human('Joe')
joe.listen()
hangoutWith(joe)

class Animal {
  String name
  public Animal(animalName) { name = animalName }
}

@Mixin(Friend)
class Dog extends Animal {
  public Dog(dogName) { super(dogName) }
}

def buddy = new Dog("Buddy")
buddy.listen()
hangoutWith(buddy)

class Cat extends Animal {
  public Cat(catName) { super(catName) }
}

//def alf = new Cat("Alf")
//alf.listen()

def fluff = new Cat("Fluff")
fluff.metaClass.mixin Friend
fluff.listen()

sundae = new Cat("Sundae")
println sundae.class
sundae.metaClass.mixin Friend
sundae.listen()
hangoutWith(sundae)

sundae.mixedIn.mixinClasses.each {
  println it.mixinClass
}